<?php
namespace LWS\WOOREWARDS\Core;

// don't call the file directly
if( !defined( 'ABSPATH' ) ) exit();

/** Manage set of Event/Unlockable with PointStack. */
class Ajax
{
	function __construct()
	{
		add_action('wp_ajax_lws_woorewards_user_points_history', array($this, 'userPointsHistory'));
	}

	function userPointsHistory()
	{
		$user = isset($_GET['user']) ? intval($_GET['user']) : false;
		$stack = isset($_GET['stack']) ? \sanitize_key($_GET['stack']) : false;
		if( !$user )
			$user = \get_current_user_id();
		if( empty($user) || empty($stack) )
			\wp_die(__("Point system or user not found.", LWS_WOOREWARDS_DOMAIN), 404);

		if( $user != \get_current_user_id() && !\current_user_can('manage_rewards') )
			\wp_die(__("You do not have permission to see other history.", LWS_WOOREWARDS_DOMAIN), 403);

		$page = isset($_GET['page']) ? \absint($_GET['page']) : false;
		$count = isset($_GET['count']) ? max(\intval($_GET['count']), 1) : false;

		$stack = \LWS\WOOREWARDS\Collections\PointStacks::instanciate()->create($stack, $user, 'ajax');
		$points = $stack->getHistory(false, true, $page, $count);

		$date_format = \get_option('date_format');
		foreach($points as &$point)
			$point['op_date'] = \mysql2date($date_format, $point['op_date']);
		\wp_send_json($points);
	}
}
