<?php
namespace LWS\WOOREWARDS\Events;

// don't call the file directly
if( !defined( 'ABSPATH' ) ) exit();

/** Earn point each time a customer complete an order. */
class OrderCompleted extends \LWS\WOOREWARDS\Abstracts\Event
{
	public function getDisplayType()
	{
		return _x("Place an order", "getDisplayType", LWS_WOOREWARDS_DOMAIN);
	}

	protected function _fromPost(\WP_Post $post)
	{
		return $this;
	}

	protected function _save($id)
	{
		return $this;
	}

	protected function _install()
	{
		\add_filter('lws_woorewards_wc_order_done_'.$this->getPoolName(), array($this, 'orderDone'), 101);
	}

	function orderDone($order)
	{
		if( !($userId = $order->order->get_customer_id('edit')) )
			return $order;

		$reason = \LWS\WOOREWARDS\Core\Trace::byOrder($order->order)
			->setProvider($order->order->get_customer_id('edit'))
			->setReason(array("Order #%s completed", $order->order->get_order_number()), LWS_WOOREWARDS_DOMAIN);

		$this->addPoint($userId, $reason);
		return $order;
	}

	/** Never call, only to have poedit/wpml able to extract the sentance. */
	private function poeditDeclare()
	{
		__("Order #%s completed", LWS_WOOREWARDS_DOMAIN);
	}

	/**	Event categories, used to filter out events from pool options.
	 *	@return array with category_id => category_label. */
	public function getCategories()
	{
		return array_merge(parent::getCategories(), array(
			'woocommerce' => __("WooCommerce", LWS_WOOREWARDS_DOMAIN),
			'order' => __("Order", LWS_WOOREWARDS_DOMAIN)
		));
	}
}

?>